#include <J3ML/LinearAlgebra/AxisAngle.hpp>
#include <J3ML/LinearAlgebra/Quaternion.hpp>
namespace J3ML::LinearAlgebra {

    AxisAngle::AxisAngle() : axis(Vector3::Zero), angle(0) {}

    AxisAngle::AxisAngle(const Vector3& axis, float angle) : axis(axis), angle(angle) {}


    AxisAngle::AxisAngle(const Quaternion& rhs) {
        float halfAngle = std::acos(rhs.w);
        angle = halfAngle * 2.f;
        float reciprocalSinAngle = 1.f / std::sqrt(1.f - rhs.w*rhs.w);

        axis = { rhs.x*reciprocalSinAngle, rhs.y*reciprocalSinAngle, rhs.z*reciprocalSinAngle };
    }

    AxisAngle::AxisAngle(const EulerAngleXYZ& e) {
        auto a = AxisAngle(Quaternion(e));
        axis = a.axis;
        angle = a.angle;
    }
}